import { MiddlewareParamArray } from '@midwayjs/decorator';
export declare type ApiTypes = 'add' | 'delete' | 'update' | 'page' | 'info' | 'list';
export interface CurdOption {
    prefix?: string;
    api: ApiTypes[];
    pageQueryOp?: QueryOp | Function;
    listQueryOp?: QueryOp | Function;
    insertParam?: Function;
    before?: Function;
    infoIgnoreProperty?: string[];
    entity: {
        entityKey?: any;
        connectionName?: string;
    } | any;
    service?: any;
}
export interface LeftJoinOp {
    entity: any;
    alias: string;
    condition: string;
}
export interface JoinOp {
    entity: any;
    alias: string;
    condition: string;
    type: 'innerJoin' | 'leftJoin';
}
export interface FieldEq {
    column: string;
    requestParam: string;
}
export interface QueryOp {
    keyWordLikeFields?: string[];
    where?: Function;
    select?: string[];
    fieldEq?: string[] | FieldEq[];
    addOrderBy?: {};
    /**
     * @deprecated 请采用更灵活的 join 配置
     */
    leftJoin?: LeftJoinOp[] | JoinOp[];
    join?: JoinOp[];
    extend?: Function;
}
export interface ControllerOption {
    curdOption?: CurdOption | string;
    routerOptions?: {
        sensitive?: boolean;
        middleware?: MiddlewareParamArray;
        alias?: string[];
        description?: string;
        tagName?: string;
    };
}
export declare function CoolController(curdOption?: CurdOption | string, routerOptions?: {
    sensitive?: boolean;
    middleware?: string[];
    description?: string;
    tagName?: string;
}): ClassDecorator;
