"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Event = exports.COOL_EVENT_KEY = exports.CoolEvent = exports.COOL_CLS_EVENT_KEY = void 0;
const decorator_1 = require("@midwayjs/decorator");
exports.COOL_CLS_EVENT_KEY = 'decorator:cool:cls:event';
function CoolEvent() {
    return (target) => {
        // 将装饰的类，绑定到该装饰器，用于后续能获取到 class
        decorator_1.saveModule(exports.COOL_CLS_EVENT_KEY, target);
        // 保存一些元数据信息，任意你希望存的东西
        decorator_1.saveClassMetadata(exports.COOL_CLS_EVENT_KEY, {}, target);
        // 指定 IoC 容器创建实例的作用域，这里注册为请求作用域，这样能取到 ctx
        decorator_1.Scope(decorator_1.ScopeEnum.Request)(target);
    };
}
exports.CoolEvent = CoolEvent;
exports.COOL_EVENT_KEY = 'decorator:cool:event';
/**
 * 事件
 * @param eventName
 * @returns
 */
function Event(eventName) {
    return (target, propertyKey, descriptor) => {
        // 将装饰的类，绑定到该装饰器，用于后续能获取到 class
        decorator_1.attachClassMetadata(exports.COOL_EVENT_KEY, {
            eventName,
            propertyKey,
            descriptor
        }, target);
    };
}
exports.Event = Event;
//# sourceMappingURL=event.js.map